<?php	// TWIG		Module Framework Processor ?>
<?php

 Function getmicrotime()
	{
 	$mtime = microtime();
 	$mtime = explode( " ", $mtime );
 	$mtime = $mtime[1] + $mtime[0];
 	return( $mtime );
	}

 $ts1 = getmicrotime();

 $config_dir = "config/";
 $version = "2.7.4";
 $config = array();
 $dbconfig = array();
 $vhosts = array();
 $img = array();

 if(!ereg("/$", $config_dir)) {$config_dir .= "/";}

 // Load the config options
 require( $config_dir . "config.inc.php3" );	// Global Configuration Variables

 // Load the image source files
 require( $config_dir . "images.inc.php3" );

 // Load the database config file
 require( $config_dir . "dbconfig.inc.php3" );

 // Load virtual host configuration files if they exist
 if( $vhosts[$SERVER_NAME] ) 
	{ 
	if( !ereg("/$",$vhosts[$SERVER_NAME]) ) {$vhosts[$SERVER_NAME] .= "/";}
	if( is_readable( $vhosts[$SERVER_NAME] . "config.inc.php3" ) ) { include( $vhosts[$SERVER_NAME] . "config.inc.php3" ); }
	if( is_readable( $vhosts[$SERVER_NAME] . "dbconfig.inc.php3" ) ) { include( $vhosts[$SERVER_NAME] . "dbconfig.inc.php3" ); }
	if( is_readable( $vhosts[$SERVER_NAME] . "images.inc.php3" ) ) { include( $vhosts[$SERVER_NAME] . "images.inc.php3" ); }
 	}

 // Set up database
 if( !$dbconfig["sqltype"] ) { $dbconfig["sqltype"] = "mysql"; }
 require( "lib/db/" . $dbconfig["sqltype"] . ".db.inc.php3" );

 if( !$config["imap_servertype"] ) { $config["imap_servertype"] = "php-imap"; }

 // See if imap path has trailing folder delimiter and add it if needed
 if ($config["imap_path"] && (strrpos($config["imap_path"], $config["mail_folder_delimiter"]) != (strlen($config["imap_path"]) - 1))) { $config["imap_path"] .= $config["mail_folder_delimiter"]; }

 require( "lib/mail/" . $config["imap_servertype"] . ".inc.php3" );	// include the mail subsystem

 require( "lib/auth/" . $config["auth"] . ".inc.php3" );		// include the auth system...

 if( !$config["default_feature"] ) { $config["default_feature"] = "main"; }
 require( "lib/session/" . $config["session_handler"] . ".session.php3" );	// include the session data handler...

 require( "lib/login/" . $config["login_handler"] . ".login.php3" );	// include the login data handler...
 require( "features/common.inc.php3" );					// include common functions...
 require( "lib/security/" . $config["security"] . ".inc.php3" );	// include security system...

 // Set default URL paths
 $config["baseurl"] = $config["basedir"] . "/" . $config["index"];

 // Set default IMAP parameters
 if( !$config["imap_server"] ) { $config["imap_server"] = "localhost"; }
 if( !$config["imap_port"] ) { $config["imap_port"] = "143"; } 

 // Tell browsers not to cache us.  The if is a hack to get around a problem in IE, I hate this hack but see no other way
 if( !$attachment )
	{
	Header( "Cache-Control: no-cache" );
	Header( "Pragma: no-cache" );
	Header( "Expires: Tue, Jan 12 1999 01:01:01 GMT" );
	}

 $context = TWIGGetContext(); 
 $session = TWIGGetSession();
 $login = TWIGGetLogin();

 if( $GoToFeature ) { TWIGGoToFeature( $GoToFeature ); parse_str( $context["options"] ); }
 if( $newmailbox ) { $session["mailbox"] = $newmailbox; }

 $mbox = TWIGAuth( "TWIG", $logout );

 // Load defaults
 require( $config_dir . "defaults.inc.php3" );
 if( $vhosts[$SERVER_NAME] && is_readable( $vhosts[$SERVER_NAME] . "defaults.inc.php3" ) ) { include( $vhosts[$SERVER_NAME] . "defaults.inc.php3" ); }

 // Load the prefs code.
 require( "features/shared/prefs.inc.php3" );

 // Find out what the preferred language is... 
 $config["language"] = GetPref( "language", $dbconfig["global_prefs_table"], $config["defaults"]["global"]["language"] );
 // ...then load the current feature's language strings and the global language strings
 TWIGLoadLanguageFile( "features/" . $context["feature"] . "/strings/", "", $config["language"] );
 TWIGLoadLanguageFile( "lib/strings/", "", $config["language"] );

 require( "features/" . $context["feature"] . "/" . $context["feature"] . ".inc.php3" );

 $sorted[0] = 1;

 // Set group info
 if( !$config["groups"] ) { $config["groups"] = "standard"; }
 require( "lib/groups/" . $config["groups"] . ".groups.inc.php3" );

 // ----- Output begins here ------

 echo "<html";
 if( $config["htmltag"] ) { echo " " . $config["htmltag"]; }
 echo ">\n";
 if( $config["metaheaders"] ) { echo $config["metaheaders"]; }
?>
<head>
<title><?php echo $pagetitle;?></title>
</head>

<?php
 if( $vhosts[$SERVER_NAME] && is_readable($vhosts[$SERVER_NAME] . "header.inc.php3") ) {include($vhosts[$SERVER_NAME] . "header.inc.php3");}
 else {include($config_dir . "header.inc.php3");}

 if( !$TWIGNoHeader ) { include( "features/twig.header.inc.php3" ); }
 flush();
 require( "features/" . $context["feature"] . "/" . $context["feature"] . ".feature.php3" );
 flush();
 if( !$TWIGNoFooter ) { include( "features/twig.footer.inc.php3" ); }

 if( $vhosts[$SERVER_NAME] && is_readable($vhosts[$SERVER_NAME] . "footer.inc.php3") ) {include($vhosts[$SERVER_NAME] . "footer.inc.php3");}
 else {include($config_dir . "footer.inc.php3");}

 TWIGCloseMB( $mbox );
 TWIGDebug( "Page output time - " . ( getmicrotime() - $ts1 ) );
?>
</html>
