<?php	// TWIG	Sybase Functions

 Function TWIGProcessSQLString( $string )
	{
	global $config;

	if( !$config["GMQRUN"] ) { $config["GMQRUN"] = get_magic_quotes_runtime() + 1; }

	if( $config["GMQRUN"] == 2 )
		{
		return stripslashes( $string );
		}
	else
		{
		return $string;
		}
	}

 Function SQLString( $string ) 
	{		
  	$string = addslashes( $string );
  
	return $string;
 	}

 Function createSqlDate( $year, $month, $day ) 
	{
	$months = array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

   	return sprintf( "%s %2d %4d %%", $months[$month - 1], $day, $year);
 	}

 Function createSqlDateTime( $year, $month, $day, $hour, $min, $sec ) 
	{
   	return sprintf( "%04d%02d%02d %02d:%02d.%02d", $year, $month, $day, $hour, $min, $sec );
 	}

 Function convertUTimetoSQLTime( $utime )
	{
	$fields = explode( " ", date( "Y m d H i s", $utime ) );

   	return createSqlDateTime( $fields[0], $fields[1], $fields[2], $fields[3], $fields[4], $fields[5] );
	}

 Function convertSQLTimetoUTime( $sqldate ) 
	{
	$months = array(	"Jan" => 1, "Feb" => 2, "Mar" => 3, "Apr" => 4,
				"May" => 5, "Jun" => 6, "Jul" => 7, "Aug" => 8,
				"Sep" => 9, "Oct" => 10, "Nov" => 11, "Dec" => 12 );

	list( $month, $day, $year, $hour, $min, $sec, $millis ) = split( ":", ereg_replace( " +", ":", $sqldate ), 7 );

	if( ereg( "AM$", $millis ) )
		{
		if( $hour == 12 )
			{
			$hour = 0;
			}
		}
	else
		{
		if( $hour != 12 )
			{
			$hour += 12;
			}
		}

	return( mktime( $hour, $min, $sec, $months[$month], $day, $year ) );
 	}

 Function MakeInsertString( $data ) 
	{
  	while( list( $key, $val ) = each( $data ) ) 
		{
    		if( $val != "--remove" ) 
			{
      			$fields[] = $key;

			if( ereg( "^[0-9]+$", $val ) )			// integer
				{
				$values[] = SQLString( $val );
               			}
			else
				{
				$values[] = "'" . SQLString( $val ) . "'";
               			}
            		}
  		}

  	$string["fields"] .= implode( ", ", $fields );
  	$string["values"] .= implode( ", ", $values );
  
	return $string;
	}	 

 Function MakeUpdateString( $data ) 
	{
  	while( list( $key, $val ) = each( $data ) ) 
		{
    		$temp[] = $key . " = '". SQLString( $val ) . "'";
   		}

  	$strings .= implode( ", ", $temp );

  	return $strings;
 	} 

 Function dbQuery( $statement ) 
	{
  	global $dbconfig;

  	sybase_pconnect( $dbconfig["sqlserver"], $dbconfig["sqlusername"], $dbconfig["sqlpassword"] );
	sybase_select_db( $dbconfig["defaultdb"] );

  	$result = sybase_query( $statement );

  	return $result;
 	}

 Function dbResult( $result, $i, $field ) 
	{
  	return sybase_result( $result, $i, $field );
 	}

 Function dbNumRows( $result ) 
	{
        return sybase_num_rows( $result ); 
 	}

 Function dbResultArray( $result, $i ) 
	{
  	@sybase_data_seek( $result, $i );
  
	return sybase_fetch_array( $result );
 	}

 Function dbLastInsertID( $result, $table )
 	{
	$sql = "SELECT @@identity";
	$res dbQuery( $sql );
	$ret = dbResultArray( $res, 0 );
	return $ret[0];
	}

 Function dbStoreBLOB( $table, $id, $field, $blob )
 	{
	$sql = "UPDATE $table SET $field = '" . addslashes( $blob ) . "' WHERE id = '$id'";
	$res = dbQuery( $sql );
	return $res;
	}

 Function dbRetrieveBLOB( $table, $id, $field, $blob = "" )
 	{
	$sql = "SELECT $field FROM $table WHERE id = '$id'";
	$res = dbQuery( $sql );
	if( dbNumRows( $res ) == 1 )
		{
		$ret = dbResultArray( $res, 0 );
		return $ret[$field];
		}
	elseif( dbNumRows( $res ) < 1 )
		{
   		TWIGPrintError( "dbRetrieveBLOB: no rows found matching id '$id' in table '$table'" );
		}
	elseif( dbNumrows( $res ) > 1 )
		{
   		TWIGPrintError( "dbRetrieveBLOB: id '$id' was not unique in table '$table'" );
		}
	return FALSE;
	}

?>
